/* PISO-P64 Linux Static Libary.

   Author: Golden Wang

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   Use vi or gvim to edit this file and set tabstop=4.

   v 0.0.0  12  Sep 2007 by Golden Wang
     function created for digital I/O.

*/

#include "piodio.h"

extern char device_module[LINE_SIZE + 1];
extern dev_control_t *dev_ctl;

/* PISO-P64 digital input data */
WORD PISOP64_Digital_Input(WORD fd, WORD port, WORD *di_data)
{
  ixpio_reg_t ri;

  switch (port)
  {
    case PISOP64_DIA:
    case PISOP64_DIB:
    case PISOP64_DIC:
    case PISOP64_DID:
    case PISOP64_DIE:
    case PISOP64_DIF:
    case PISOP64_DIG:
    case PISOP64_DIH:
        ri.id = port;
        break;
    default:
        return PIODA_PORT_DEFINED_ERROR;
  }

  if (PIODA_InputByte(fd, &ri)) return PIODA_DIGITAL_INPUT_ERROR;

  *di_data = ri.value;

  return SUCCESS;
}
